# SPDX-FileCopyrightText: 2024 fortiss GmbH
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileContributor: Hongyu Zhu, fortiss

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>AGVs Control Plane</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="{{ url_for('static', filename='css/main.css') }}">
    <script src="https://cdn.jsdelivr.net/npm/eventemitter2@6.4.9/lib/eventemitter2.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/roslib@1/build/roslib.min.js"></script>
</head>
<body>
    <div class="bg"></div>
    <div class="container content">
        <h2 class="text-center">AGV Controller Plane</h2>
        <h3>CODECO Nodes and Pods</h3>
        <table class="table table-bordered table-striped table-hover">
            <thead class="thead-dark">
                <tr>
                    <th>Node Name</th>
                    <th>Status</th>
                    <th>Pods</th>
                </tr>
            </thead>
            <tbody>
                {% for node in nodes %}
                <tr>
                    <td>{{ node.node_name }}</td>
                    <td>{{ node.status }}</td>
                    <td>
                        <ul>
                            {% for pod in node.pods %}
                                <li>{{ pod.pod_name }} (Namespace: {{ pod.namespace }}) - Status: {{ pod.status }}</li>
                            {% endfor %}
                        </ul>
                    </td>
                </tr>
                {% endfor %}
            </tbody>
        </table>
        
        <!-- New Table for Pod Latencies -->
        <h3>Pod Latencies</h3>
        <table class="table table-bordered table-striped table-hover">
            <thead class="thead-dark">
                <tr>
                    <th>Pod Name</th>
                    <th>Container Name</th>
                    <th>Latency (seconds)</th>
                </tr>
            </thead>
            <tbody>
                {% for latency in pod_latencies %}
                <tr>
                    <td>{{ latency.pod }}</td>
                    <td>{{ latency.container }}</td>
                    <td>{{ latency.latency }}</td>
                </tr>
                {% endfor %}
            </tbody>
        </table>

        <!-- Add workloads assign sheets -->
        <div class="workload-assignment">
            <h3>Assign Workload to AGVs</h3>
            <form action="/deploy" method="post">
                <div class="form-group">
                    <label for="workload">Workloads:</label>
                    <select name="workload" id="workload" class="form-control">
                        <option value="teleoperation">Teleoperation</option>
                        <option value="slam">slam</option>
                    </select>
                </div>
                <div class="form-group">
                    <label for="node">Turtlebots:</label>
                    <select name="node" id="node" class="form-control">
                        <option value="turtlebot1">turtlebot1</option>
                        <option value="turtlebot2">turtlebot2</option>
                    </select>
                </div>
                <button type="submit" class="btn btn-primary">Deploy</button>
            </form>
        </div>
        <!-- Turtlebot Control Panel -->
        <div class="turtlebot-control mt-5">
            <h3 class="text-center">Turtlebot Control</h3>
            <div id="virtual-keyboard" class="text-center">
                <button class="btn btn-secondary control-btn" id="forward">forward</button>
                <button class="btn btn-secondary control-btn" id="left">left</button>
                <button class="btn btn-secondary control-btn" id="stop">stop</button>
                <button class="btn btn-secondary control-btn" id="right">right</button>
                <button class="btn btn-secondary control-btn" id="backward">backward</button>
            </div>
        </div>
    </div>

<script type="text/javascript">
 
    // Maximum velocity constants
    const BURGER_MAX_LIN_VEL = 0.22;
    const BURGER_MAX_ANG_VEL = 2.84;
    const LIN_VEL_STEP_SIZE = 0.01;
    const ANG_VEL_STEP_SIZE = 0.1;

    // Current velocity state
    let currentLinVel = 0.0;
    let currentAngVel = 0.0;

    // Connecting to ROS
    const ros = new ROSLIB.Ros({
        url: 'ws://localhost:8080'
    });

    ros.on('connection', () => {
        console.log('Connected to ROS Bridge.');
    });

    ros.on('error', (error) => {
        console.error('Error connecting to ROS Bridge:', error);
    });

    ros.on('close', () => {
        console.log('Disconnected from ROS Bridge.');
    });

    function sendCommand(command) {
        const cmdVel = new ROSLIB.Topic({
            ros: ros,
            name: '/cmd_vel',
            messageType: 'geometry_msgs/Twist'
        });

        const twist = new ROSLIB.Message({
            linear: { x: command.linear, y: 0.0, z: 0.0 },
            angular: { x: 0.0, y: 0.0, z: command.angular }
        });

        cmdVel.publish(twist);
    }

    document.getElementById('forward').onclick = () => {
        currentLinVel = Math.min(currentLinVel + LIN_VEL_STEP_SIZE, BURGER_MAX_LIN_VEL);
        sendCommand({ linear: currentLinVel, angular: 0.0 });
    };

    document.getElementById('backward').onclick = () => {
        currentLinVel = Math.max(currentLinVel - LIN_VEL_STEP_SIZE, -BURGER_MAX_LIN_VEL);
        sendCommand({ linear: currentLinVel, angular: 0 });
    };

    document.getElementById('left').onclick = () => {
        currentAngVel = Math.min(currentAngVel + ANG_VEL_STEP_SIZE, BURGER_MAX_ANG_VEL);
        sendCommand({ linear: 0.0, angular: currentAngVel });
    };

    document.getElementById('right').onclick = () => {
        currentAngVel = Math.max(currentAngVel - ANG_VEL_STEP_SIZE, -BURGER_MAX_ANG_VEL);
        sendCommand({ linear: 0.0, angular: currentAngVel });
    };

    document.getElementById('stop').onclick = () => {
        currentLinVel = 0.0;
        currentAngVel = 0.0;
        sendCommand({ linear: 0.0, angular: 0.0 });
    };
</script>
</body>
</html>
